<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 ** Component: cases
 **
 ** WEB interface for several operations:
 **
 **  - Removing studies      (single/batch)
 **
 **  Delete operations will be confirmed first.
 **
 **  @param cGr           Study Instance UID of study to be deleted
 **  @param cBack         URL to go back after delete
 **  @param cConfirmed    Confirmed Removing studies operation
 **  @param cDeleteForced Deleting a study is forced even if the study is not deletable
 **  @param cKeepReport   Keep report objects when deleting study/studies
 **  @param cInvalidate   Invalidate existing objects by timestamp 
 **  @param cFolder       Deleting study from this folder
 **
 ** $Date: 2014/01/17 14:48:31 $
 **
 *
 *  RCS File Name    : $RCSfile: delete.jsp,v $
 *  RCS Revision     : $Revision: 1.8 $
 *  Locked by        : $Locker:  $
 *  Symbolic name    : $Name:  $
 *  State             : $State: Exp $
-- %><%@page import="java.util.Iterator"%>
<%@page import="java.util.Arrays"%>
<%@page import="java.util.Enumeration"%>
<%@page import="java.util.Vector"%>
<%@page import="java.io.PrintWriter"%>
<%@page import="java.util.StringTokenizer"%>
<%@page import="java.sql.ResultSet"%>
<%@page import="java.util.Properties"%>
<%@page import="java.sql.PreparedStatement"%>
<%@page import="java.util.HashSet"%>
<%@page import="java.io.IOException"%>
<%@page import="java.sql.SQLException"%>
<%@page import="java.util.Hashtable"%>
<%@page import="java.util.Collection"%>
<%@
	page import="imagemed.util.*,imagemed.types.*,imagemed.types.number.*,imagemed.types.string.*,imagemed.exception.*,
			  imagemed.imsession.*,imagemed.jsputil.*,com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			  imagemed.dcprocessing.StudyRemover, java.text.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static final String m_tabPage = "cases/index.jsp";
	
	static final String m_classError = "BgPriorityHiRow";
	static final String m_classWarning = "BgCorrectionHiRow";
	static final String m_classLink = "BgShortCutRow";
	

	private static class Infos {

		private static String[] m_TABLE_FIELDS = new String[] { "PANM", "ACCN", "PAID", "MODY", "STAT", "DATE" };

		/** Studies not yet sent to external archive */
		Collection<String> m_notConfirmedStudies;

	 	/** Undeletable studies */
		Collection<String> m_undeletableStudies;
	 	
	 	/** Shortcuts */
		Collection<String> m_shortcuts;
	 	/** Studies having shortcuts */
		Collection<String> m_havingShortcuts;
	 	/** Orders */
		Collection<String> m_orders;
		
		/** Map of locked studies - lock message id of hover table row */
		Hashtable<String, String> m_lockedStudies;
		
		/** Studies successfully locked for deletion; map of studies - lock IDs */
		Hashtable<String, String> m_locks;

		/** Patient Names for log entries */
		String m_logPatientNames;
		/** Modalities for log entries */
		String m_logModalities;

		/** HoverTable to be used to display errors/warnings */
		HoverTable m_hoverTable;

		/** Array of studies/shortcuts to be deleted */
		String[] m_studies;
		
		/** Indicates whether studies need to be locked (false) or existing locks need to be checked (true) */
		boolean m_lockCheckOnly;
		
		/** Constructs a new Infos object
		 *
		 * @param hoverTable    HoverTable to be used to display errors/warnings
		 * @param studies       Array of studies/shortcuts to be deleted
		 * @param lockCheckOnly Indicates whether studies need to be locked (false) or existing locks need to be checked (true)
		 */
		Infos( HoverTable hoverTable, String[] studies, boolean lockCheckOnly ) {
			m_hoverTable = hoverTable;
			m_studies = studies;
			m_lockCheckOnly = lockCheckOnly;

			m_notConfirmedStudies = null;
			m_undeletableStudies = null;
			m_shortcuts = null;
			m_havingShortcuts = null;
			m_orders = null;
			m_lockedStudies = null;
			m_locks = null;

			m_logPatientNames = null;
			m_logModalities = null;
		}
	
		/**
	 	 * Checks if studies are deletable, confirmed by external archive, shortcuts or having shortcuts.
	 	 * Undeletable studies (DontDelete attribute is set) will be added to undeletableStudies.
	 	 * Studies not confirmed by external archives will be added to notConfirmedStudies
	 	 * Shortcuts will be added to shortcuts.
	 	 * Studies having shortcuts will be added to havingShortcuts.
	 	 * 
	 	 * @param is                    session info ("IMLockID" in is.sessionVariables should be set);
	 	 *
		 * @throws SQLException	in case prepareStatement fails
		 * @throws IOException if an I/O error occurs
		 * @throws IMException if any other error occurs
	 	 */
		void checkStudies( IMSession is ) throws SQLException, IOException, IMException {
			if ( m_studies == null )
				return;

			m_notConfirmedStudies = StudyRemover.checkRemovable( m_studies );
			m_orders = new HashSet<String>();
			m_undeletableStudies = new HashSet<String>();
			m_shortcuts = new HashSet<String>();
			m_havingShortcuts = new HashSet<String>();
			m_lockedStudies = new Hashtable<String, String>();
			m_locks = new Hashtable<String, String>();
			
			
			String q = "select STYIUID, SRCSTUDY from " + IMEnvBase.getEnv( "STUDYTBL" ) + " where STYIUID=? or SRCSTUDY=?"; 
			PreparedStatement ps = IMEnv.getDB().prepareStatement( q );
			for ( int i = 0 ; i < m_studies.length; i++ ) {
				if ( ! OperToolbox.canDeleteStudy( m_studies[ i ] ) ) {
					m_undeletableStudies.add( m_studies[ i ] );
					continue;
				}

				Properties rspLock = new Properties();
				String lockOper = m_lockCheckOnly ? "CheckLock" : "Lock";
				
				String lockId = IMLock.lockStudy( is, m_studies[ i ], lockOper, rspLock ); 
				if ( null == lockId ) {
					String lockDivId = "STUDY_LOCKED_" + i;
					String lockMsg = Helper.htmlEncode( IMLock.getLockerMessage( rspLock ) );
					m_hoverTable.add( new HoverTable.Message( lockDivId, "semLocked", "Error", lockMsg ) );
					m_lockedStudies.put( m_studies[ i ], lockDivId );
				}
				else {
					m_locks.put( m_studies[ i ], lockId );
				}
			
			
				if ( StudyToolbox.isOrder( m_studies[ i] ) ) {
					m_orders.add( m_studies[ i ] );
					continue;
				}

				ps.setString( 1, m_studies[ i ] );
				ps.setString( 2, m_studies[ i ] );
			
				ResultSet rs = ps.executeQuery();
				while ( rs.next() ) {
					String study = rs.getString( "STYIUID" );
					String source = rs.getString( "SRCSTUDY" );
				
					if ( study.equals( source ) )
						continue;
				
					if ( m_studies[ i ].equals( study ) ) {
						m_shortcuts.add( study );
					}
					else if ( m_studies[ i ].equals( source ) ) {
						m_havingShortcuts.add( source );
					}
				}
				rs.close();
			}
		}


		/**
		 * Returns value for a field from an SQL result set.
		 * This method handles fields having multiple database fields (like DATE).
		 * 
		 * @param rs      SQL result set
		 * @param field   ID of the field
		 *
		 * @return field value
		 *
		 * @throws SQLException if an SQL error occurs
		 */
		public static String getDBValue( ResultSet rs, String field ) throws SQLException {
			String dbName = IMBaseFieldManagerImpl.staticGetDbName( field );
			StringTokenizer st = new StringTokenizer( dbName, "," );
			if ( st.countTokens() < 2 ) {
				return rs.getString( dbName );
			}
	
			StringBuffer value = new StringBuffer();
			while ( st.hasMoreTokens() ) {
				String v = rs.getString( st.nextToken() );
				if ( v == null ) {
					return value.length() == 0 ? null : value.substring( 1 );
				}
				
				value.append( "_" ).append( v );
			}
			
			return value.substring( 1 );
		}


		/**
		 * Prints a table with information on studies to be deleted.
		 * Additional information will also be collected and returned for the studies.
		 * Will generate hovers with error/warning messages for table rows if needed.
		 *
		 * @param folder        Not null when deleting copies/shortcuts from a folder
		 * @param isExecute     Indicates whether delete is being executed or a is a confirmation page 
		 * @param is            Session stuff
		 *
		 * @throws IOException if an I/O error occurs
		 * @throws SQLException	in case prepareStatement fails
		 * @throws IMException if any other error occurs
		 */
		public void printStudiesTable( String folder, boolean isExecute, IMSession is ) throws IOException, SQLException, IMException {
	
			PrintWriter out = is.out;
	
			// Add warning/error column only if there is any error/warning to be reported
			boolean needErrorWarning = !m_notConfirmedStudies.isEmpty() || !m_undeletableStudies.isEmpty() || !m_havingShortcuts.isEmpty() || !m_lockedStudies.isEmpty();
	
			// Add Keep Reports checkbox if there is any regular study to be deleted and all studies are deletable
			boolean needKeepReports = m_studies.length > m_shortcuts.size() && m_undeletableStudies.isEmpty();
	
			// There is any non order study to delete
			boolean needInvalidate = needKeepReports && ( m_orders.size() < m_studies.length - m_shortcuts.size() );
			
			// Turn off Keep Reports and Invalidate on execution page and when deleting from folder
			if ( isExecute || folder != null ) {
				needKeepReports = false;
				needInvalidate = false;
			}
			
			StringBuffer logNames = new StringBuffer();
			StringBuffer logModalities = new StringBuffer();
			
			
			boolean invalidateDefault = "deleteImmediately".equals( IMEnv.getConfigProperty( IMEnvBase.getEnv( "IFACE_VAR" ) + "/edit.cfg", "DeleteMode" ) );
	
			out.println();
			out.println( "<table border=1 width=\"100%\" cellpadding=0 cellspacing=0>" );
	
			// Print header
			out.println( "<TR class=HeaderRow>" );
	
			if ( needErrorWarning ) {
				out.println( "<TD>&nbsp;</TD>" );
			}
			for ( int i = 0; i < m_TABLE_FIELDS.length; i++ ) {
				out.println( Helper.headerCell3D( IMBaseFieldManagerImpl.staticGetUiName( m_TABLE_FIELDS[ i ] ) ) );
			}
			if ( needKeepReports ) {
				out.println( "<TD class=BgShadow align=center>" + LocalizedMessage.getSimpleMessage( "CASES_DELETE_KEEP_REPORTS" ) + "</TD>" );
			}
			if ( needInvalidate ) {
				out.println( "<TD class=BgShadow align=center>" + LocalizedMessage.getSimpleMessage( "CASES_DELETE_IMMEDIATE" ) + "</TD>" );
			}
	
			// Support for multiple studies
			if ( m_studies != null ) {
				StringBuffer qStudy = new StringBuffer();
				qStudy.append( "SELECT PNAME,MODALITY" );
				for ( int i = 0; i < m_TABLE_FIELDS.length; i++ ) {
					qStudy.append( "," ).append( IMBaseFieldManagerImpl.staticGetDbName( m_TABLE_FIELDS[ i ] ) );
				}
				qStudy.append( " FROM " ).append( IMEnvBase.getEnv( "STUDYTBL" ) ).append( " WHERE STYIUID=?" );
	
				PreparedStatement stStudy = IMEnv.getDB().prepareStatement( qStudy.toString() );
	
				for ( int j = 0; j < m_studies.length; j++ ) {
					String study = m_studies[ j ];
	
					try {
						stStudy.setString( 1, study );
						ResultSet resultStudy = stStudy.executeQuery();
						if ( resultStudy.next() ) {
							out.println( "<!-- " + study + "-->" );
	
							String cellClass = null;
							String icon = null;
							Vector<String> messages = new Vector<String>();
							
							if ( m_undeletableStudies.contains( study ) ) {
								cellClass = m_classError;
								messages.add( "DELETE_ERROR_CANT_DELETE" );
	//							icon = "semLocked";
								icon = "warning";
								out.println( "<!-- Error : " + cellClass + "-->" );
							}
							else if ( m_undeletableStudies.isEmpty() ) {
								if ( m_lockedStudies.containsKey( study ) ) {
									cellClass = m_classError;
									messages.add( m_lockedStudies.get( study ) ); 
									icon = "semLocked";
									out.println( "<!-- Locked : " + cellClass + "-->" );
								}
								
								if ( m_notConfirmedStudies.contains( study ) ) {
									cellClass = cellClass == null ? m_classError : cellClass;
									messages.add( "DELETE_CONFIRM_NOT_ARCHIVED" ); 
	//								icon = "semLocked";
									icon = "warning";
									out.println( "<!-- Error : " + cellClass + "-->" );
								}
							
								if ( m_shortcuts.contains( study ) ) {
									cellClass = cellClass == null ? m_classLink : cellClass;
									out.println( "<!-- Shortcut : " + cellClass + "-->" );
								}
								else if ( m_havingShortcuts.contains( study ) ) {
									cellClass = cellClass == null ? m_classWarning : cellClass;
									messages.add( "DELETE_WARNING_HAVE_LINKS" );
									icon = icon == null ? "warning" : icon;
									out.println( "<!-- Warning : " + cellClass + "-->" );
								}
							}
	
							if ( cellClass == null ) {
								cellClass = "BgLight";
							}
	
							out.println( "<TR>" );
	
							if ( needErrorWarning ) {
								out.print( "<TD class=BgMedDark align=center" );
								if ( !messages.isEmpty() ) {
									m_hoverTable.printOnMouseOver( out, messages, false );
									m_hoverTable.printOnMouseOut( out, false );
								}
								out.print( ">" );
								
								if ( icon == null ) {
									out.print( "&nbsp;" );
								}
								else {
									out.print( JSHelper.getJsImage( is, icon, "" ) );
								}
								out.println( "</TD>" );
							}
							
							for ( int i = 0; i < m_TABLE_FIELDS.length; i++ ) {
								String fld = m_TABLE_FIELDS[ i ];
								String dbValue = getDBValue( resultStudy, fld );
								String value = IMType.getTypeFor( fld, IMBaseFieldManagerImpl.staticGetVR( fld ) ).displayText( dbValue );
	
								if ( value == null || value.equals( "" ) ) {
									value = "&nbsp;";
								}
								
								out.print( "<TD class=" + cellClass );
								if ( !messages.isEmpty() ) {
									m_hoverTable.printOnMouseOver( out, messages, false );
									m_hoverTable.printOnMouseOut( out, false );
								}
								out.print( ">" );
								if ( is.isNetscape() ) {
									out.print( "<font size=2>" );
								}
								out.print( "&nbsp;" + value + "&nbsp;" );
								if ( is.isNetscape() ) {
									out.print( "</font>" );
								}
								out.print( "</TD>" );
							}
							
							if ( needKeepReports ) {
								out.print( "<TD class=BgMedDark align=center>" );
								if ( m_shortcuts.contains( study ) ) {
									out.print( JSHelper.getJsImage( is, "/imadmin/art/cross.gif", "" ) );
								}
								else {
									String disabled = invalidateDefault ? " disabled" : "";
									out.print( "<input id=\"keepreport_" + j + "\" type=checkbox name=cKeepReports value=\"" + study + "\"" + disabled + ">" );
								}
								out.println( "</TD>" );
							}
							if ( needInvalidate ) {
								out.println( "<!-- NEED INVALIDATE: " + invalidateDefault + " -->" );
								out.print( "<TD class=BgMedDark align=center>" );
								if ( m_shortcuts.contains( study ) || m_orders.contains( study ) ) {
									out.print( JSHelper.getJsImage( is, "/imadmin/art/cross.gif", "" ) );
								}
								else {
									String checked = invalidateDefault ? " checked" : "";
									out.print( "<input id=\"invalidate_" + j + "\" type=checkbox name=cInvalidate value=\"" + study + "\" onClick=\"changeKeepReport(" + j + ");\"" + checked + ">" );
								}
								out.println( "</TD>" );
							}
							
							out.print( "</TR>\n" );
	
							String pn = IMType.getTypeFor( "PN" ).displayText( resultStudy.getString( "PNAME" ) );
							logNames.append( "\\" ).append( pn );
							logModalities.append( "\\" ).append( resultStudy.getString( "MODALITY" ) );
						}
						resultStudy.close();
					}
					catch ( Throwable th ) {
						out.println( "<!-- " + Helper.throwable2String( th ) + " -->" );
					}
				}
				out.println( "</table>\n" );
			}
	
			String collapsedPN = "";
			String collapsedModalities = "";
	
			if ( logNames.length() != 0 ) {
				collapsedPN = IMType.getTypeFor( "PN" ).collapse( logNames.substring( 1 ) );
				collapsedPN = Helper.replace( collapsedPN, "\\", "; " );
			}
	
			if ( logModalities.length() != 0 ) {
				collapsedModalities = IMType.getTypeFor( "MODY" ).collapse( logModalities.substring( 1 ) );
			}
	
			m_logModalities = collapsedModalities;
			m_logPatientNames = collapsedPN;
			return;
		}
	

		/**
		 * Prints HIDDEN form elements to pass study lock information
		 *
		 * @param is session stuff
		 *
		 * @throws IOException if an I/O error occurs
		 * @throws SQLException	if an SQL error occurs
		 * @throws IMException if any other error occurs
		 */
		void printHiddenLocks( IMSession is ) throws IOException, SQLException, IMException {
			for ( Enumeration<String> e = m_locks.keys(); e.hasMoreElements(); ) {
				String lStudy = e.nextElement();
				String lId = m_locks.get( lStudy );
				String srcStudy = StudyToolbox.getSourceStudyDB( lStudy );
				String unlockID = Helper.encodeList( new String[] { srcStudy, lId } );
				is.out.println( "<INPUT type=\"hidden\" name=\"cLocks\" value=\"" + unlockID + "\">" );
			}
		}
	}
	
%><%-- Input Parameters -- %><%

	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}

	String[] parGrArray = request.getParameterValues( "cGr" );
	String parBack = request.getParameter( "cBack" );
	// Delete operation is confirmed do the actual delete
	boolean isConfirmed = "true".equals( request.getParameter( "cConfirmed" ) );
	String folder = request.getParameter( "cFolder" );
	boolean lockCheckOnly = "true".equals( request.getParameter( "cCheckLock" ) );

	if ( null == parBack ) {
		parBack = request.getHeader( "Referer" );
	}
	if ( null == parBack ) {
		parBack = "javascript:self.history.back();";
	}

	if ( parGrArray == null ) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "GENERAL_BATCH_NO_STUDIES" ), "cases/index.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_BATCH_ERROR_TITLE" ), parBack, 4 );
	}
	
	if ( "".equals( folder ) ) {
		folder = null;
	}

	try {
		folder = Helper.URLDecodeUTF8( folder );
	}
	catch ( Exception e ) {
	}


	// Check rights to delete studies/orders
	boolean bDeleteRight = is.hasRight( imagemed.types.flag.PacsRight.Delete.letterString() );
	boolean bOrderRight  = is.hasRight( imagemed.types.flag.IMTypeur.SCHEDULING_RIGHT );
	bDeleteRight = bDeleteRight || (bOrderRight && OperToolbox.isDeletableOrders( parGrArray ) );
	if ( !bDeleteRight && folder == null) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DELETE_NO_RIGHTS" ), "cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DELETE_ERROR_TITLE" ), parBack, 4 );
	}
	
	Defs casesDefs = new Defs(is, null);

	
	HoverTable hoverTable = new HoverTable( "delHover", new HoverTable.Position(HoverTable.OffsetType.ABSOLUTE, 50, HoverTable.OffsetType.ELEMENT_BOTTOMRIGHT, 5) );
	hoverTable.add( new HoverTable.Message( "DELETE_ERROR_CANT_DELETE", "warning", "Error", LocalizedMessage.getSimpleMessage( "CASES_DELETE_ERROR_CANT_DELETE" ) ) );
	hoverTable.add( new HoverTable.Message( "DELETE_CONFIRM_NOT_ARCHIVED", "warning", "Error", LocalizedMessage.getSimpleMessage( "CASES_DELETE_CONFIRM_NOT_ARCHIVED" ) ) );
	hoverTable.add( new HoverTable.Message( "DELETE_WARNING_HAVE_LINKS", "warning", "Warning", LocalizedMessage.getSimpleMessage( "CASES_DELETE_WARNING_HAVE_LINKS" ) ) );

	Infos infos = new Infos( hoverTable, parGrArray, lockCheckOnly );
	infos.checkStudies( is );

	boolean hasLocks = infos.m_locks.size() > 0;
	

%><HTML>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "termSTUDY", true) %></title>
<%
	TabToolbox.writeIMpopup(out);
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
	
	hoverTable.printJS( is );
	
	JSHelper.printJsInclude( is.out, JSHelper.JQUERY_JS );
%>

<SCRIPT language="JavaScript">
	function Jump_( pJ ) {
		document.location=pJ;
	}


	function goBack() {
		document.location='<%=parBack%>';
	}

<%
	if ( ! isConfirmed ) {
%>
	
	function changeKeepReport( i ) {
		var keepReportCH = document.getElementById( "keepreport_" + i );
		var invalidateCH = document.getElementById( "invalidate_" + i );

		if ( keepReportCH && invalidateCH ) {
			if ( invalidateCH.checked ) {
				keepReportCH.disabled = true;
			}
			else {
				keepReportCH.disabled = false;
			}
		}
	}

<%
	}

	if ( hasLocks ) {
%>
	var needUnlock = 1;

	function unlockStudies() {
		if (needUnlock) {
			if ( self.document.unlockForm ) {
				$.ajax({
					type: 'POST',
					url: '/cases/unlockwindow.jsp',
					data: getquerystring( self.document.unlockForm ),
					async: false
				});
				needUnlock = false;
			}
		}
	}

<%
	}
%>

	function submitOperForm() {
		needUnlock = 0;
			self.document.operForm.submit();
	}


</script>

</head>
<BODY <%= hasLocks ? "onUnload=\"unlockStudies();\"" : "" %>>
<%
	hoverTable.printHoverDiv( is );
%>
<CENTER>
<%
	TabToolbox.makeTabs( is,is.tabbean, m_tabPage, "White");

	StringBuilder sbPassStudies = new StringBuilder();
	if ( parGrArray != null ) {
		sbPassStudies.append( Helper.passAsForm( "cGr", parGrArray ) );
	}

	StringBuilder sbPassNoStudies = new StringBuilder();
	sbPassNoStudies.append( Helper.passAsForm("cBack", new String[] { parBack } ) );

	if ( folder != null ) {
		sbPassNoStudies.append( Helper.passAsForm( "cFolder", new String[] { folder } ) );
	}
	
	String errFontB = "<FONT color=red><B>";
	String errFontE = "</b></FONT>";

	// Print header
	ChoiceFormat studyPlural = LocalizedMessage.getStudyPluralChoice();
	ChoiceFormat toBeDeletedPlural = new ChoiceFormat( new double[]{ 1, 2 }, new String[]{ LocalizedMessage.getSimpleMessage( "CASES_DELETE_TO_BE_DELETED" ), LocalizedMessage.getSimpleMessage( "CASES_DELETE_TO_BE_DELETED_PLURAL" ) } );
	String titleMessage = null;
	
	String titleID = null;
	if ( folder == null ) {
		titleMessage = LocalizedMessage.getCompoundMessage( "CASES_DELETE_PAGE_TITLE", new Format[] { studyPlural, toBeDeletedPlural }, new Object[] { parGrArray.length, parGrArray.length }, true );
	}
	else {
		String folderName = FolderToolbox.decomposeFolderName( folder )[ 1 ];
		titleMessage = LocalizedMessage.getCompoundMessage( "CASES_DELETE_PAGE_FOLDER_TITLE", new Format[] { studyPlural, toBeDeletedPlural, null }, new Object[] { parGrArray.length, parGrArray.length, folderName }, true );
	}
	
%>
 <TABLE border=1 width="100%" cellpadding=0 cellspacing=0>
<%
	if ( hasLocks ) {
		out.println( "<FORM name=\"unlockForm\" action=\"unlockwindow.jsp\" method=\"POST\">" );
		out.println( "<INPUT type=\"hidden\" name=\"cInstant\" value=\"true\">" );
		infos.printHiddenLocks( is );
		out.println( "</FORM>" );
	}

	if ( ! isConfirmed ) {
		// start the form here
%>
<FORM name="operForm" method="POST" action="delete.jsp">
<%
		if ( hasLocks ) {
			infos.printHiddenLocks( is );
			out.println( "<INPUT type=\"hidden\" name=\"cCheckLock\" value=\"true\">" );
		}
	}

%>
  <tr><td class=BgShadow>
   <BR>
   <TABLE border=0 width="100%"><TR><TD>
    &nbsp;&nbsp;
    <FONT size=4><%= titleMessage %>:</FONT>
   </TD></tr></table>
   <br>
  </td></tr></table>
<%

	infos.printStudiesTable( folder, isConfirmed, is );

	out.flush();

	String logPatientName = ( "".equals( infos.m_logPatientNames ) ) ? "-" : infos.m_logPatientNames.replace( ' ' , '_' );
	String logModality = ( "".equals( infos.m_logModalities ) ) ? "-" : infos.m_logModalities.replace( ' ' , '_' );


	try {
		
		if ( infos.m_undeletableStudies.size() > 0 || infos.m_lockedStudies.size() > 0 ) {
			MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DELETE_ERROR_TITLE" ), "" );
			//Object[] msgArgs = new Object[] { infos.m_undeletableStudies.size() + infos.m_lockedStudies.size() };
			String messageID = (infos.m_undeletableStudies.size() + infos.m_lockedStudies.size() > 1) ? "EXCEPTION_CASES_DELETE_UNDELETABLE_PLURAL" : "EXCEPTION_CASES_DELETE_UNDELETABLE"; 
			String msg = LocalizedMessage.getSimpleMessage( messageID );
			
			mb.setMessage( "<BR>" + errFontB + msg + errFontE + "<BR><BR>" );

			if ( infos.m_undeletableStudies.size() + infos.m_lockedStudies.size() < parGrArray.length ) {
				// we may go on with the rest...
				
				mb.addButton(new Button("JavaScript:submitOperForm();", "BUTTON_SKIP_THEM", "ALT_TEXT_SKIP_THEM" ) )	;

				out.println( sbPassNoStudies.toString() );
				
				for ( int i = 0; i < parGrArray.length; i++ ) {
					if ( !infos.m_undeletableStudies.contains( parGrArray[ i ] ) && !infos.m_lockedStudies.containsKey( parGrArray[ i ] ) ) {
						out.println( "<input type=hidden name=\"cGr\" value=\"" + parGrArray[ i ] + "\">" );
					}
					else {
						out.println("<!-- skipping : cGr :: " + parGrArray[ i ] + " -->" );
					}
				}
				
//				Enumeration<?> enum0 = request.getParameterNames();
//				while ( enum0.hasMoreElements() ) {
//					String name = ( String ) enum0.nextElement();
//					String[] values = request.getParameterValues( name );
//					
//					if ( ! "cGr".equals( name ) ) {
//						continue;
//					}
//					for ( int i = 0; values != null && i < values.length; i++ ) {
//						String value = values[ i ];
//						if (value == null) {
//							value = "";
//						}
//					}
//				}
			}

			throw new IMMessageBoxException( mb, m_tabPage, 0, parBack );
		}


		// --- Execute deleting, go to cBack then ---
		if ( isConfirmed ) {
			Button backButton = new Button(parBack, "BUTTON_BACK", "ALT_TEXT_BACK");

			boolean isDeleteForced = "true".equals(request.getParameter("cDeleteForced"));
			String[] parKeepReports = request.getParameterValues("cKeepReports");
			String[] parInvalidates = request.getParameterValues("cInvalidate" );

			if (folder != null) {
				for (int i = 0; i < parGrArray.length ; i++) {
					FolderToolbox.removeFromFolder(is, folder, parGrArray[i], casesDefs.getUser());
				}
			}
			else {
				Vector<String> rules = null;
				Vector<String> studies = new Vector<String>( Arrays.asList( parGrArray ) );
				Vector<String> keepReportStudies = null;
				if ( parKeepReports != null && parKeepReports.length > 0 ) {
					keepReportStudies = new Vector<String>( Arrays.asList( parKeepReports ) );
				}

				if ( parInvalidates != null && parInvalidates.length > 0 ) {
					for ( int i = 0; i < parInvalidates.length; i++ ) {
						studies.remove( parInvalidates[ i ] );
						if ( keepReportStudies != null ) {
							keepReportStudies.remove( parInvalidates[ i ] );
						}
					}
					StudyToolbox.deleteStudies( parInvalidates, casesDefs.getUser(), isDeleteForced, null, true );
				}
				
				
				if ( keepReportStudies != null && !keepReportStudies.isEmpty() ) {
					// Perform partial delete first
					rules = new Vector<String>();
					rules.add("!report");
					
					for ( Iterator<String> iter = keepReportStudies.iterator(); iter.hasNext(); ) {
						studies.remove( iter.next() );
					}

					StudyToolbox.deleteStudies( keepReportStudies.toArray( new String[0] ), casesDefs.getUser(), isDeleteForced, rules, false );
				}

				if ( !studies.isEmpty() ) {
					StudyToolbox.deleteStudies( studies.toArray( new String[0] ), casesDefs.getUser(), isDeleteForced, null, false );
				}
			}

			String message = null;
			if ( folder == null ) {
				String messageID = "CASES_DELETE_REMOVED_FROM_WL";
				if ( parGrArray.length > 1 )
					messageID += "_PLURAL";
				message = LocalizedMessage.getSimpleMessage( messageID );
			}
			else {
				String messageID = "CASES_DELETE_REMOVED_FROM_FOLDER";
				if ( parGrArray.length > 1 )
					messageID += "_PLURAL";
				String folderName = FolderToolbox.decomposeFolderName( folder )[ 1 ];
				message = LocalizedMessage.getCompoundMessage( messageID, new Format[] { null }, new Object[] { folderName }, true );
			}
			

			MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_DELETE_COMPLETED_TITLE" ), "" );
			mb.setMessage( "<h3><br>" + message + "</br></h3>" );
			throw new IMMessageBoxException( mb, m_tabPage, 4, parBack );
		}

		// --- HTML II ------------------------------------------------------------

		// 'true' or 'report'
		boolean NO_DELETE = !"false".equals( IMEnv.getConfigProperty( IMEnvBase.getEnv( "CONF" ) + "/limit.conf", "NO_DELETE" ) );

		StringBuffer confirmMessage = new StringBuffer(256);

		if ( !infos.m_notConfirmedStudies.isEmpty() ) {
			confirmMessage.append( "<DIV style=\"padding: 5; color: red; font-weight: bold; text-align: left;\">" );
			if ( infos.m_notConfirmedStudies.size() > 1 ) {
				confirmMessage.append( LocalizedMessage.getSimpleMessage( "CASES_DELETE_NOTARCHIVED_WARNING_PLURAL" ) );
			}
			else {
				confirmMessage.append( LocalizedMessage.getSimpleMessage( "CASES_DELETE_NOTARCHIVED_WARNING" ) );
			}
			confirmMessage.append( "</DIV>" );
			out.println( "<input type=hidden name=\"cDeleteForced\" value=\"true\">" );
		}
			
		if ( folder == null ) { // deleting from worklist
			confirmMessage.append( "<DIV style=\"padding: 5; font-weight: bold; text-align: left;\">");
			if ( parGrArray.length > 1 ) {
				confirmMessage.append( LocalizedMessage.getSimpleMessage( "CASES_DELETE_CONFIRM_PLURAL" ) );
			}
			else {
				confirmMessage.append( LocalizedMessage.getSimpleMessage( "CASES_DELETE_CONFIRM" ) );
			}
			confirmMessage.append( "</DIV>" );
		}

			
%>
  <TABLE border=1 width="100%" cellpadding=0 cellspacing=0>
  <tr><td class=BgShadow align="center">
   <BR>&nbsp;
  </td></tr>
<%

		if ( confirmMessage.length() > 0 ) {
%>
  <tr><td class=BgLight align="center">
   <TABLE border=0><TR><TD>
    <%= confirmMessage.toString() %>
   </TD></tr></table></td></tr>
<%
		}
%>
  <tr><td class=BgShadow align=right>
  <BR>
  <INPUT type="hidden" name="cConfirmed" value="true"/>
  <a href="JavaScript:submitOperForm();">
  	  <%= JSHelper.getJsLocalizedButton( "BUTTON_DELETE", "BUTTON_NULL", false ) %>
  </a>
<%
		//Button.printJsInputButton(is, "Delete", "cDel", "Delete");
%>
  &nbsp; &nbsp; &nbsp; &nbsp;
  <a href="<%=parBack%>">
  		<%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %>
  </a>
  <BR>
  </td></tr>
  <tr><td class=FieldBlock class=FieldBlock style="padding-top: 0; height: 18;">&nbsp;</td></tr>
  </table>

<%= sbPassStudies.toString() %>
<%= sbPassNoStudies.toString() %>

<%
	}
	catch ( IMMessageBoxException mbe ) {
%>
<table border=1 width="100%" cellpadding=0 cellspacing=0>
 <tr><td class=BgShadow><BR>&nbsp;<BR></td></tr>
 <tr><td class=FieldBlock style="padding-top: 0; height: 18;">&nbsp;</td></tr>
</table>
<%
		out.println( mbe.getHtmlMessage( is ) );
	}

	if ( ! isConfirmed ) {
%>
</form>
<%
	}
%>
</body>
</html>
--%>