<%--
 * Component: cases
 *
 * Description:
 *   Editing images/documents attached to a study
 *
 * Parameters:
 *   cStudy    : [R] study instance UID of the study
 *   cAttName  : [R] Identifies the attachment to be edited 
 *	  cAttType  : [R] Attachment type (PACS or SCHEDULER) 
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="java.io.PrintWriter"%>
<%@
	page import="java.util.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*"
%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.http.rmi.RMIException"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%-- Input Parameters --%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	String pageTitle = LocalizedMessage.getSimpleMessage( "EDIT_ATTACHMENT_PAGE_TITLE" );

%><HTML><HEAD><TITLE><%= Helper.htmlEncode( pageTitle ) %></TITLE><%
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( new PrintWriter(out) );

%>
<STYLE type="text/css">
	DIV.header {
		margin: 0px;
		padding: 15px;
		font-style: bold;
		font-size: larger;
	}
	
</STYLE>
</HEAD><BODY class="BgShadow" style="padding: 0px; margin: 0px;">
<%
	boolean isPACSOrder = "true".equals( request.getParameter( "cPACSOrder" ) );
	String study = request.getParameter( "cStudy" );
	String orderNum = request.getParameter( "cOrderNum" );
	String attachmentName = request.getParameter( "cAttName" );
	String attachmentType = request.getParameter( "cAttType" );
	
	AttachmentManager.STORAGE_TYPE storage = AttachmentManager.STORAGE_TYPE.valueOf( attachmentType );
	
	String orderId = study;
	// boolean isPACSOrder = storage.equals( AttachmentManager.STORAGE_TYPE.PACS );
	if ( !isPACSOrder && orderNum != null ) {
		orderId = orderNum;
	}
	
	String parOp = request.getParameter( "cOp" );
	if ( "change".equals( parOp ) ) {
		String docType = request.getParameter( "cDocType" );
		if ( docType == null ) {
			out.print( "<DIV class=\"FontError\">" );
			out.print( Helper.htmlEncode( LocalizedMessage.getSimpleMessage( "EDIT_ATTACHMENT_ERROR_NO_DOCTYPE" ) ) );
			out.println( "</DIV>" );
			out.println( "</BODY></HTML>" );
			return;
		}
		AttachmentManager.Attachment att = AttachmentManager.getAttachment( sess, orderId, isPACSOrder, attachmentName, attachmentType );
		if ( att.changeDocType( docType ) ) {
			out.print( "<DIV class=\"FontOK\" style=\"text-align: center; padding: 10px;\">" );
			out.print( Helper.htmlEncode( LocalizedMessage.getSimpleMessage( "EDIT_ATTACHMENT_UPDATED" ) ) );
			out.println( "</DIV>" );
			out.println( "<SCRIPT language=\"JavaScript\">setTimeout('parent.reloadPage();', 2000);</SCRIPT>" );
			out.println( "</BODY></HTML>" );
			return;
		}
		else {
			out.print( "<DIV class=\"FontError\">" );
			out.print( Helper.htmlEncode( LocalizedMessage.getSimpleMessage( "EDIT_ATTACHMENT_ERROR_SAVE_FAILED" ) ) );
			out.println( "</DIV>" );
			out.println( "</BODY></HTML>" );
			return;
		}
	}
	
	
	AttachmentManager.Attachment att = AttachmentManager.getAttachment( sess, orderId, isPACSOrder, attachmentName, attachmentType );

	//out.println( "<PRE>" );
	//out.println( orderId );
	//out.println( isPACSOrder );
	//out.println( attachmentName );
	//out.println( attachmentType );
	//out.println( "</PRE>" );
	
	if ( att == null ) {
		out.print( "<DIV class=\"FontError\">" );
		out.print( Helper.htmlEncode( LocalizedMessage.getSimpleMessage( "EDIT_ATTACHMENT_ERROR_NOT_FOUND" ) ) );
		out.println( "</DIV>" );
		out.println( "</BODY></HTML>" );
		return;
	}
	
	
	String curDocType = att.getDocType();
	String docTypeBehavior = AttachmentManager.getBehavior( curDocType );
	
	if ( docTypeBehavior == null ) {
		//docTypeBehavior = attachmentType.equals( "PACS" ) ? "Study" : "Order";
		docTypeBehavior = "Document";
	}
%>

<DIV class="header" width="100%"><%= Helper.htmlEncode( pageTitle ) %></DIV>

<!-- DIV width="100%" style="padding: 50px;">
<%= attachmentType %> / <%= orderId %><BR/>
<%= att.getName() %><BR/>
<%= curDocType %> : 
<%= AttachmentManager.getDoctypeDisplayNameFromID( curDocType ) %><BR/> 
Behavior: <%= docTypeBehavior %><BR/>
</DIV -->


<FORM name="editForm" action="editAttachment.jsp" method="POST" style="display: inline;">
<INPUT type="hidden" name="cStudy" value="<%=Helper.htmlEncode( study ) %>" />
<% if ( orderNum != null ) { %> 
<INPUT type="hidden" name="cOrderNum" value="<%=Helper.htmlEncode( orderNum ) %>" />
<% } %> 
<% if ( isPACSOrder ) { %> 
<INPUT type="hidden" name="cPACSOrder" value="true" />
<% } %> 
<INPUT type="hidden" name="cAttName" value="<%=Helper.htmlEncode( attachmentName ) %>" /> 
<INPUT type="hidden" name="cAttType" value="<%=Helper.htmlEncode( attachmentType ) %>" /> 
<INPUT type="hidden" name="cOp" value="change" />

<TABLE width="100%" border="1" cellspacing="0" cellpadding="0" style="border-collapse: collapse;">
<TR class=HeaderRow>
 <%= Helper.headerCell3D( LocalizedMessage.getSimpleMessage( "GENERIC_FIELD" ), "center", 1 ) %>
 <%= Helper.headerCell3D( LocalizedMessage.getSimpleMessage( "GENERIC_VALUE" ), "center", 1 ) %>
</TR>
<TR><TD class="BgMedDark" width="40%" style="padding: 2px 10px;">
 <%= LocalizedMessage.getSimpleMessage( "EDIT_ATTACHMENT_DOCUMENT_TYPE" ) %>:
</TD><TD class=BgShadow  style="padding: 2px 10px;">
<%
	out.println( "<SELECT NAME=\"cDocType\">" );
	List<String> docTypes = AttachmentManager.getDocumentTypesID( docTypeBehavior );
	for ( String docType : docTypes ) {
		out.print( "<OPTION VALUE=\"" + docType + "\"" );
		if ( docType.equals( curDocType ) ) {
			out.print( " SELECTED" );
		}
		out.println( ">" + AttachmentManager.getDoctypeDisplayNameFromID( docType ) + "</OPTION>" );
	}
	out.println( "</SELECT>" );
	
	String msgSave = LocalizedMessage.getSimpleMessage( "ALT_TEXT_SAVE" );
%>
</TD></TR>
<TR><TD colspan=2 align=right class=BgShadow style="padding-top: 10px; padding-bottom: 10px;">
 <SPAN style="padding-right: 15px;">
 <A HREF="javascript:self.document.editForm.submit();" title="<%= msgSave %>" onMouseOver="window.status='<%= msgSave %>'; return true">
 <%= JSHelper.getJsLocalizedButton( "BUTTON_SAVE", "ALT_TEXT_SAVE", false ) %>
 </a></SPAN>
</TD></TR>

</TABLE>
</FORM>
<DIV style="padding: 20px;">
<%
	if ( att.getType() == AttachmentManager.TYPE.PDF ) {
		String url = att.getFrames().firstElement().getUrl( sess );
		out.print( "<A href=\"" + url + "\"><IMG src=\"/cases/art/pdfDoc.gif\" width=24 height=32></A>" );
	}
	else {
		Vector<AttachmentManager.Frame> frames = att.getFrames();
		for ( AttachmentManager.Frame frame : frames ) {
			out.print( "<IMG src=\"" + frame.getUrl( sess )+ "\" width=128 style=\"margin: 5px;\"/>" );
		}
	}
%>
</DIV>
</BODY></HTML>
