<%--
 * Component: cases
 *
 * Description:
 *    Returns the report for a study in a processable form for the viewer.
 *
 * Parameters:
 * 
 *    study : study instance uid of the study
 *    lock  : lock mode (defaults to 'lock', can also be 'breaklock')
 *
--%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.util.*,
			imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*, imagemed.repohandler.*,
			com.erad.pacs.modules.gwt.session.right.PacsRight,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.connector.Connector,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			com.erad.pacs.common.interfaces.AkacFacade"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	Syslog logger = new Syslog( "getrep", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );

	if ( ProxyToolbox.init( sess, null, logger ) ) {
		// Session parameters were proxied from parent child, regID must be set. 
		if ( sess == null || sess.getUser() == null ) {
			logger.syslog( Syslog.LOG_ERR, "No user ID was received from parent/child");
			return;
		}
	}

	String parStudy = request.getParameter("study");
	
	// Translate Link Study UID to Source Study UID
	parStudy = StudyToolbox.getSourceStudyDB( parStudy );
	
	String redirHost = RedirectToolbox.getRedirectForStudy( sess, parStudy );
	if (redirHost != null) {
		response.sendRedirect( redirHost + "/cases/getrep.jsp?" + RedirectToolbox.getRedirectParams( sess, request ) );
		return;
	}

	/* proxy kikotve, amugy is false-ot adott vissza */
//	try {
//		if ( !StudyToolbox.isOrder( parStudy ) && ProxyToolbox.checkAndProxy( sess, parStudy, false ) ) {
//	logger.syslog(Syslog.LOG_INFO, "getrep request for " + parStudy + " has been proxied to owner device" );
//	return;
//		}
//	}
//	catch (Throwable th) {
//		logger.syslog(Syslog.LOG_ERR, "Exception " + Helper.throwable2String( th ) );
//		return;
//	}

	String parLock = request.getParameter("lock");
	if (parLock == null)
		parLock = "Lock";

	if (!ReportToolbox.checkUserAgent(request.getHeader( "user-agent" ), response))
		return;

	boolean bRight = false;

		bRight = sess.getRights().hasAnyOf( PacsRight.Edit, PacsRight.Report, PacsRight.SetStatus, PacsRight.Transcribe);

	String studyDirName = imagemed.repohandler.RepositoryHandler.getLocation(Repository.DICOM, parStudy);
	ReportToolbox.moveOldReportToDicomData(studyDirName, parStudy);

//	NO!
//	if (!bRight && is.regRights != null) {
//		// Lock is enabled with transcription and/or edit rights
//		// remove these rights
//		is.regRights = Helper.replace(is.regRights,"E","");
//	}

	Properties prpTimes = null;
	Properties prpHeaders = Report.getReportLock(sess, parStudy, parLock, IMLock.getLockIDFromRequest( sess, request, null ));

	if (!bRight)
		prpHeaders.setProperty("IMLock","NORIGHT");

	if (null != prpHeaders.getProperty("IMLockOwner"))
		response.setHeader("IMLockOwner",prpHeaders.getProperty("IMLockOwner"));
	if (null != prpHeaders.getProperty("IMLockAge"))
		response.setHeader("IMLockAge",prpHeaders.getProperty("IMLockAge"));
	if (null != prpHeaders.getProperty("IMLock"))
		response.setHeader("IMLock",prpHeaders.getProperty("IMLock"));
	if (null != prpHeaders.getProperty("IMLockID"))
		response.setHeader("IMLockID",prpHeaders.getProperty("IMLockID"));
	if (null != prpHeaders.getProperty("IMAuthentication"))
		response.setHeader("IMAuthentication",prpHeaders.getProperty("IMAuthentication"));
	if ("true".equals(prpHeaders.getProperty("IM_INTERRUPTED")))
		response.setHeader("IMLock","INTERRUPTED");

	int nWaitTime = 30000;
	int nElapsed = 0;

	while (ReportToolbox.hasNewerReport(sess, prpTimes, parStudy) && nElapsed < nWaitTime) {
		Thread.sleep(50);
		nElapsed += 50;
	}

	if (ReportToolbox.hasNewerReport(sess, prpTimes, parStudy)) {
		response.setHeader("IMReport","MODIFIED");
		if (bRight) {
			AkacFacade.unlockStudy( sess, parStudy, IMLock.getLockIDFromRequest( sess, request, null ) );
		}
	}

	int res = ReportToolbox.parseReport(sess, request, response, parStudy);
	if (res == ReportToolbox.PR_INVALID_VERSION) {
		// This should not be happen with new (SR) reports
		// itt meg lehetne hivni a convertert, es ujra probalkozni
		out.println("INVALID REPORT VERSION");
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}%>
