<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *   Set Retrieve and DontEdit flags from remote Dotcom server:
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State             : $State$
-- %><%@
	page import="imagemed.util.*, imagemed.imsession.*, imagemed.jsputil.*, java.util.*,
			imagemed.exception.IMException, imagemed.dotcom.*, imagemed.taskd.IMScriptContext"

	
%><%-- Input Parameters -- %><%

	IMSession is = new IMSession( request, response, out );

	String parStudy = request.getParameter( "study" ); // study   - Study IUID
	String parDontEditFlag = request.getParameter( "cDontEdit" ); // set DontEdit flag
	String parRetrievedFlag = request.getParameter( "cRetrieved" ); // set Retrieved flag
	String parSourceDevice = request.getParameter( "cSourceDevice" ); // Source
	String parArchiveDevice = request.getParameter( "cArchiveDevice" ); // Archive device
	String parDerived = request.getParameter( "cDerived" ); // Derivation information

	// true indicates to set attributes for an order
	// the order may not exist on local server at the time of the attribute setting request (issued before forward)
	boolean isOrder = "true".equals( request.getParameter( "cOrder" ) );  
	
	boolean bSetDontEdit = false; // default
	boolean bSetRetrieved = false; // default

	boolean isRecursive = "true".equals( request.getParameter( "cRecursive" ) );

	if ( parDontEditFlag != null )
		bSetDontEdit = "yes".equals( parDontEditFlag );
	if ( parRetrievedFlag != null )
		bSetRetrieved = "yes".equals( parRetrievedFlag );


	Syslog s = new Syslog( "setStudyAttribute", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	String errMsg = null;

	if ( parStudy == null ) {
%>false<%
		return;
	}

	try {
		Properties prpDevice = DotcomToolbox.checkClient( is, null, false );
		String peerId = prpDevice.getProperty( "ID" );
		if ( peerId == null )
			throw new IMException( "Peer ID is null" );

		IMProperties prpSelfRec = new IMProperties();
		prpSelfRec.recRead( IMEnvBase.getEnv( "CONF" ) + "/self.rec" );

		StoreState storestate = new StoreState( parStudy );
		boolean isNew = !storestate.load();

		boolean wasArchiveChanged = false;
		
		Vector<String> modStorestate = new Vector<String>();
		if ( isNew ) {
			// The storestate.rec file does not exist
			modStorestate.add( "--processmode" );
			modStorestate.add( prpSelfRec.getProperty( "ProcessMode", "Process" ) );
			modStorestate.add( "--setowner" );
			modStorestate.add( peerId );
			storestate.setMode( StoreState.CREATE_ONLY );
			storestate.modify( modStorestate );
			modStorestate.clear();
			storestate.setMode( StoreState.EDIT_ANY );
		}

		if ( bSetRetrieved ) {
			modStorestate.add( "--retrieved" );
			modStorestate.add( "yes" );
		}

		if ( bSetDontEdit ) {
			modStorestate.add( "--dontedit" );
			modStorestate.add( "yes" );
		}

		if ( parSourceDevice != null ) {
			modStorestate.add( "--source" );
			modStorestate.add( parSourceDevice );
		}

		if ( parArchiveDevice != null ) {
			modStorestate.add( "--archive" );
			modStorestate.add( parArchiveDevice );

			String origArchiveDevice = storestate.getArchiveDevice();
			wasArchiveChanged = !isNew && !parArchiveDevice.equals( origArchiveDevice );
		}
		
		if ( parDerived != null ) {
			modStorestate.add( "--derived" );
			modStorestate.add( parDerived );
		}

		if ( !modStorestate.isEmpty() ) {
			storestate.modify( modStorestate );
			// modify reloads storestate.rec

			// check and fix child_references after archive device get changed
			if ( wasArchiveChanged && !DotcomConfig.selfDevice().isDbOnly() ) {
				storestate.fixChildReferences();
			}
		}
		
		// Check if received from non-StudyTop direction
		boolean needSetChildRef = false;
		// child_ reference need not be set on CWL servers
		if ( ! DotcomConfig.selfDevice().isDbOnly() ) {
			// Current server is a regular (ie. non CWL) server
			String parent = storestate.getNextToStudyTop( DotcomConfig.selfDevice() );
			if ( !peerId.equals( parent ) ) {
				// peer is not the study-parent -> child
				needSetChildRef = true;
				if ( isOrder ) {
					DotcomDevice dev = DotcomConfig.getConfig().getDevice( peerId );
					if ( dev != null && dev.isDbOnly() && !dev.hasMultipleClusters() ) {
						// XXX: This check should remain consistent with the check in storestate.getNextToStudyTop() !!!
						// do not set child reference if request was received for an order from single cluster CWL server
						needSetChildRef = false;
					}
				}
			}
		}
		if ( needSetChildRef ) {
			// Add child_<device> reference to STUDYDIR
			ReferenceCounter.createReference( "STUDYDIR", parStudy, "child_" + peerId );
		}

		if ( isRecursive ) {
			IMScriptContext context = IMScriptContext.readJobContextFrom( request );
			StudyAttributes.synchronizeAttributes( context, parStudy, peerId, false );
		}
	}
	catch ( Throwable th ) {
		errMsg = th.getMessage() == null ? "EXCEPTION: " + th.toString() : th.getMessage();
		s.syslog( Syslog.LOG_ERR, errMsg );
	}

	response.setContentType( "text/plain" );

	if ( errMsg == null )
		response.setStatus( 200 );
	else
		response.setStatus( 500 );

%><%= errMsg == null ? "true" : "false" %><%

	if ( true )
		return; // jsp puts an extra '\n' if we don't return
%>--%>