#!/bin/sh
#
# Component: qr
#
# Description:
#   OBSOLETE [7.0]
#   Removes archive_..._get reference from a study after an unsuccessful retrieve attempt.
#   Also removes the archive_..._get references from staged devices.
#
# Usage:
#   clearArchiveRef.sh -s <study> -r <reference> [-x <exceptHost>]
#
#    - study:      Study Instance UID of the study tried to be retrieved
#    - reference:  full name of the archive_..._get reference to be removed
#    - exceptHost: do not remove the reference on this device even if staged
#                  (device ID of the device the request was received from)
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

# if clearArchiveRef.sh is called directly:
# run as a task instead
if [ `basename $0` = "clearArchiveRef.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi


LOGGER="/usr/bin/logger"
TAG="clearArchiveRef"

if [ -z "$RETRY_NUM" ] ; then
	RETRY_NUM=0
	export RETRY_NUM
fi

study=""
reference=""
exceptDevice=""
INV_PARAM=""
PASS_PARAMS=""

while getopts 's:r:x:' OPT; do
	case $OPT in
	s) study="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -s \"$OPTARG\"" ;;
	r) reference="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -r \"$OPTARG\"" ;;
	x) exceptDevice="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -x \"$OPTARG\"" ;;
	*) INV_PARAM="Invalid_Parameter:$OPT" ;;
	esac
done

#
# Override default run_ method
#
run_()
{
	[ -n "$INV_PARAM" ] && return 0
	[ -z "$study" ] && return 0
	[ -z "$reference" ] && return 0

	$TASKD_HOME/runjavacmd -c "0 qr.ClearArchiveRef $PASS_PARAMS" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
}


print_()
{
	$TASKD_HOME/runjavacmd -c "print qr.ClearArchiveRef $PASS_PARAMS" -p "$JAVA_SERVER_PORT"
}
